%global packname  ps
%global rlibdir  %{_libdir}/R/library

# Tests requires processx which requires this package.
%global with_test 1

Name:             R-%{packname}
Version:          1.1.0
Release:          3%{?dist}
Summary:          List, Query, Manipulate System Processes

License:          BSD
URL:              https://cran.r-project.org/web/packages/%{packname}/index.html
Source0:          https://cran.r-project.org/src/contrib/%{packname}_%{version}.tar.gz
# https://github.com/r-lib/ps/pull/42
Patch0001:        0001-Handle-failure-from-sysconf.patch
Patch0002:        0002-Invert-the-sense-of-psll_linux_clock_ticks.patch
Patch0003:        0003-Use-safer-comparison-for-process-start-time.patch

# Here's the R view of the dependencies world:
# Depends:
# Imports:   R-utils
# Suggests:  R-callr, R-covr, R-processx >= 3.1.0, R-R6, R-rlang, R-testthat, R-tibble
# LinkingTo:
# Enhances:

Requires:         R-utils
Suggests:         R-tibble
BuildRequires:    R-devel
BuildRequires:    tex(latex)
BuildRequires:    R-utils
BuildRequires:    R-R6
BuildRequires:    R-rlang
BuildRequires:    R-tibble
%if %{with_test}
BuildRequires:    R-callr
BuildRequires:    R-processx >= 3.1.0
BuildRequires:    R-testthat
%endif

%description
List, query and manipulate all system processes, on 'Windows', 'Linux' and
'macOS'.


%prep
%setup -q -c -n %{packname}

pushd %{packname}
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
popd

# Don't need coverage; it's not packaged either.
sed -i 's/covr, //g' %{packname}/DESCRIPTION


%build


%install
mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css


%check
%if %{with_test}
%{_bindir}/R CMD check %{packname}
%else
_R_CHECK_FORCE_SUGGESTS_=0 %{_bindir}/R CMD check %{packname} --no-tests
%endif


%files
%dir %{rlibdir}/%{packname}
%doc %{rlibdir}/%{packname}/html
%{rlibdir}/%{packname}/DESCRIPTION
%license %{rlibdir}/%{packname}/LICENSE
%doc %{rlibdir}/%{packname}/NEWS.md
%doc %{rlibdir}/%{packname}/internals.md
%{rlibdir}/%{packname}/INDEX
%{rlibdir}/%{packname}/NAMESPACE
%{rlibdir}/%{packname}/Meta
%{rlibdir}/%{packname}/R
%{rlibdir}/%{packname}/help
%{rlibdir}/%{packname}/bin
%dir %{rlibdir}/%{packname}/libs
%{rlibdir}/%{packname}/libs/%{packname}.so


%changelog
* Wed Sep 05 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 1.1.0-3
- Improve process checking on 32-bit systems

* Mon Aug 20 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 1.1.0-2
- Add option to disable tests due to dependency loop

* Sun Aug 19 2018 Elliott Sales de Andrade <quantum.analyst@gmail.com> - 1.1.0-1
- initial package for Fedora
